#ifndef PARTIAL_H
#define PARTIAL_H

#include"table.h"

struct partial {
	unsigned partial : 12;
	unsigned offset : 10;
	unsigned count : 10;
};
#define PARTIAL_SIZE (sizeof(struct partial))

struct partial_entry {
	struct partial partial;
	list_ptr_t ptr;
};

union partial_entry_node {
	struct partial_entry partial;
	union partial_entry_node *next;
};

union partial_node {
	struct partial partial;
	union partial_node *next;
};

struct partial_table {
	int file;
	table_t free;
	list_pool_t pool;
	list_t lru;
	struct partial_table_base {
		union partial_node *partial;
		union partial_entry_node *entry;
	} base;
	struct partial_table_avail {
	};
	int size[2];
	lock_t free;
};
#define PARTIAL_TABLE_SIZE (sizeof(struct partial_table))

unsigned partial_size(unsigned size, unsigned short count);

struct partial_table *partial_new(struct partial_table *table, unsigned table_size, unsigned size, unsigned short count);
void partial_dispose(struct partial_table *table, int free);

struct partial *partial_extend(struct partial_table *table, struct partial *head, unsigned short count);
int partial_trim(struct partial_table *table, struct partial *head, unsigned short count);

#endif
