#include<pthread.h>

#include"ds.h"
#include"node.h"

int enter(node_t *node) {
	pthread_t self;
	listptr_t ptr;
	void *entry;
	int success;

	success = 1;
	self = pthread_self();
	entry = list_get(self->list.node, GET_FIRST, &ptr);
	while(entry && entry != node) entry = list_get(self->list.node, GET_NEXT, &ptr);
	if(! entry) {
		while(++*node != 1) {
			--*node;
			pthread_switch();
		}
		if(! list_insert(self->list.node, node, NULL)) success = -2;
	}
	return success;
}

int exit(node_t *node) {
	pthread_t self;
	listptr_t ptr;
	void *entry;
	int success;

	success = 1;
	self = pthread_self();
	entry = list_get(self->list.node, GET_FIRST, &ptr);
	while(entry && entry != node) entry = list_get(self->list.node, GET_NEXT, &ptr);
	if(entry) {
		--*node;
		if(! list_delete(self->list.node, &ptr)) success = -2;
	}
	return success;
}
