#ifndef PARTIAL_H
#define PARTIAL_H

#include"mutex.h"

struct partial {
	unsigned partial;
	unsigned short offset;
	unsigned short count;
	struct partial *next;
};
#define PARTIAL_SIZE (sizeof(struct partial))

struct partial_free {
	struct partial *partial;
	struct partial_free *left, *right;
};
#define PARTIAL_FREE_SIZE (sizeof(struct partial_free))

union partial_free_node {
	struct partial_free free;
	union partial_free_node *next;
};

struct partial_free_table {
	table_t free;
	struct partial *least, *most;
	union partial_free_node *base, *avail;
	struct partial_free *root;
	pthread_mutex_t free;
};

struct partial_table {
	table_t free;
	struct partial *least, *most;
	struct partial *base, *avail;
	unsigned size;
	struct partial_table_mutex {
		lock_t avail, free;
	} mutex;
};
#define PARTIAL_TABLE_SIZE (sizeof(struct partial_table))

unsigned partial_size(unsigned size, unsigned short count);

struct partial_table *partial_new(struct partial_table *table, unsigned table_size, unsigned size, unsigned short count);
void partial_dispose(struct partial_table *table, int free);

struct partial *partial_extend(struct partial_table *table, struct partial *head, unsigned short count);
int partial_trim(struct partial_table *table, struct partial *head, unsigned short count);

#endif
