#ifndef VISIT_H
#define VISIT_H

#include"lock.h"

#ifndef PTHREADS_MAX
#define PTHREADS_MAX (64)
#endif

#define VISIT_NODE_MAX (PTHREADS_MAX * 3)

struct visit {
	void *node;
	pthread_mutex_t mutex;
};

union visit_node {
	struct visit visit;
	union visit_node *next;
};

struct visit_node_pool {
	union visit_node base[VISIT_NODE_MAX], *avail;
	lock_t free;
};

struct visit_entry {
	lock_t lock;
	struct visit *visit;
	struct visit_entry *left, *right;
};

struct visit_table {
	struct visit_entry base[VISIT_NODE_MAX], *root;
	struct visit_node_pool pool;
};
#define VISIT_TABLE_SIZE (sizeof(struct visit_table))

#ifndef VISIT_T
#define VISIT_T
typedef const struct visit_table * const visit_t;
#endif

visit_t visit_new();
void visit_dispose(visit_t visit);

void visit(visit_t visit, void *node);
void depart(visit_t visit, void *node);

#endif
