/*

    Partial allocation, table management

    Copyright (C) 2006  Sundaresh Venugopal

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

    email : sundaresh@mail.com

    Address : K-222, Usha's appartments, 16-th main, Jayanagar 4-th block, Bangalore - 560011

    Phone : 91-80-26651501

*/
#ifndef PARTIAL_H
#define PARTIAL_H

#include"table.h"

struct partial {
	unsigned partial : 12;
	unsigned offset : 10;
	unsigned count : 10;
};
#define PARTIAL_SIZE (sizeof(struct partial))

struct partial_entry {
	struct partial partial;
	list_ptr_t ptr;
};

union partial_entry_node {
	struct partial_entry partial;
	union partial_entry_node *next;
};

union partial_node {
	struct partial partial;
	union partial_node *next;
};

struct partial_table {
	int file;
	table_t free;
	list_pool_t pool;
	list_t lru;
	struct partial_table_base {
		union partial_node *partial;
		union partial_entry_node *entry;
	} base;
	struct partial_table_avail {
	};
	int size[2];
	lock_t free;
};
#define PARTIAL_TABLE_SIZE (sizeof(struct partial_table))

unsigned partial_size(unsigned size, unsigned short count);

struct partial_table *partial_new(struct partial_table *table, unsigned table_size, unsigned size, unsigned short count);
void partial_dispose(struct partial_table *table, int free);

struct partial *partial_extend(struct partial_table *table, struct partial *head, unsigned short count);
int partial_trim(struct partial_table *table, struct partial *head, unsigned short count);

#endif
