#ifndef CACHE_H
#define CACHE_H
/*

    Copyright (C) 2006 Sundaresh Venugopal

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

    sundaresh@mail.com

*/

#include"lock.h"
#include"mutex.h"

#include"file.h"
#include"fs.h"

struct block {
	lock_t lock;
	bool_t write;
	long address;
	void *ptr;
	struct file *file;
	list_ptr_t ptr;
};

struct block_pool {
	struct block_node *base, *avail;
	lock_t free;
};

union cache_base {
	void *memory;
	struct file *file;
};

struct cache {
	int size;
	struct fs *fs;
	union cache_base base;
	struct block_pool pool;
	list_t list;
	table_t table;
};

void *cache_read(struct cache *cache, long address, void *buffer);
struct cache *cache_write(struct cache *cache, long address, void *buffer);

#endif
