/*

    Copyright (C) 2006 Sundaresh Venugopal 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

    sundaresh@mail.com
*/

/*
 * This is one implementation of unix <io.h>
 */

#include"file.h"
#include"fs.h"

#include"list.h"
#include"table.h"

/* Max files, fs maintained by the O/S */
#ifndef FILE_MAX
#define FILE_MAX ()
#endif

#ifndef FS_MAX
#define FS_MAX ()
#endif

union file_node {
	struct file file;
	union file_node *next;
};

struct file_table {
	union file_node base[FILE_MAX], *avail;
	lock_t free;
	table_t table;
};

union fs_node {
	struct fs fs;
	union fs_node *next;
};

struct fs_table {
	union fs_node base[FS_MAX], *avail;
	lock_t free;
	table_t table;
};

/* These tables are maintained by the O/S and common to all process's */
volatile struct file_table file_table;
volatile struct fs_table fs_table;

/* Max files, fs allowed per process */
#ifndef OPEN_MAX
#define OPEN_MAX ()
#endif 

#ifndef MOUNT_MAX
#define MOUNT_MAX ()
#endif

/* These pools are per process */
extern list_t file_pool, fs_pool;

typedef struct file_lock {
	long system;
	pthread_t thread;
	struct file *file;
	long offset, count;
} * flock_t;

