/*

    Presto file system
    Copyright (C) 2006 Sundaresh Venugopal

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA


    sundaresh@mail.com
*/

#define STRETCH_LEN_MAX (65536)

struct stretch {
	unsigned offset;
	unsigned count;
};
#define STRETCH_SIZE (sizeof(stretch))

union stretch_node {
	struct stretch stretch;
	union stretch_node *next;
};

struct stretch_entry {
	struct stretch stretch;
	list_ptr_t ptr;
};

union stretch_entry_node {
	struct stretch_entry entry;
	union stretch_entry_node *next;
};

struct stretch_table {
	table_t free;
	union stretch_node *base, *avail;
	int size;
	lock_t free;
};

struct stretch_toc {
};
