
#include<time.h>

#include"mutex.h"
#include"cond.h"

int pthread_cond_init(pthread_cond_t *cond, pthread_condattr_t *attr) {
	if(cond->signal == -1) {
		do {
			if(++cond->signal == 0) {
				cond->count = 0;
				break;
			}
		} while(--cond->signal);
	}
	return 0;
}

int pthread_cond_destroy(pthread_cond_t *cond) {
	if(pthread_cond_active(cond)) errno = EACTIVE;
	cond->signal = -1;
	return errno == EACTIVE;
}

int pthread_cond_timedwait(pthread_cond_t *cond, pthread_mutex_t *mutex, struct timespec *abstime) {
	int fail;

	cond->count++;
	pthread_mutex_unlock(mutex);
	do {
       		pthread_switch();
	} while((! (abstime && past(abstime))) && (cond->signal <= 0) &&
			(fail = pthread_mutex_trylock(mutex)));
	cond->count--;
	if(cond->signal > 0) {
		if((--cond->signal) < 0) cond->signal++;
	}
	return fail;
}
