#ifndef COND_H
#define COND_H

/*
    Copyright (C) 2006  Sundaresh Venugopal

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

    sundaresh@mmail.com
*/

/* Author : sundaresh venugopal */

#include<time.h>

#include"mutex.h"

#ifndef EACTIVE
#define EACTIVE
#endif

#ifndef PTHREAD_COND_T
#define PTHREAD_COND_T
typedef struct condition {
	short signal, count;
} pthread_cond_t;
#endif

#ifndef PTHREAD_CONDATTR_T
#define PTHREAD_CONDATTR_T
typedef int pthread_condattr_t;
#endif

#define PTHREAD_COND_INITIALIZER { 0, 0 }

/* Non standard macro */
#define pthread_cond_active(cond) (((cond)->count > 0) || ((cond)->signal > 0))

int pthread_cond_init(pthread_cond_t *cond, pthread_condattr_t *attr);
int pthread_cond_destroy(pthread_cond_t *cond);
int pthread_cond_timedwait(pthread_cond_t *cond, pthread_mutex_t *mutex, struct timespec *abstime);
#define pthread_cond_wait(cond, mutex) pthread_cond_timedwait(cond, mutex, NULL)
#define pthread_cond_broadcast(cond) ((cond)->signal > 0 ? (cond)->signal = (cond)->count, 0 : 1)
#define pthread_cond_signal(cond) (pthread_cond_active(cond) ? (cond)->signal++, 0 : 1)

#endif
