#ifndef LOCK_H
#define LOCK_H


/*
    Copyright (C) 2006  Sundaresh Venugopal

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

    sundaresh@mmail.com
*/

/* Author : sundaresh venugopal */

#include<pthread.h>

#include"bool.h"
#include"list.h"

#ifndef EBUSY
#define EBUSY
#endif

#ifndef EDEADLK
#define EDEADLK
#endif

#ifndef NDEBUG || ! defined NDEADLOCK_CHECK
#define DEADLOCK_CHECK TRUE
#else
#define DEADLOCK_CHECK FALSE
#endif

#define LOCK_LIST_TYPE (LINKED_TYPE + SINGLY_LINKED)

#ifndef LOCK_T
#define LOCK_T
typedef struct lock {
	unsigned short mutex : 1;
	unsigned short lock : 15;
	pthread_t thread;
	struct lock_ptr {
		listptr_t lock, deadlock;
	} ptr;
} lock_t;
#endif

#define DEADLOCK_RETRIES (20)

void lock_init(lock_t *lock);
int trylock(lock_t *lock);
int lock(lock_t *lock);
int unlock(lock_t *lock);

#endif
