#ifndef MUTEX_H
#define MUTEX_H


/*
    Copyright (C) 2006  Sundaresh Venugopal

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

    sundaresh@mmail.com
*/

/* Author : sundaresh venugopal */

#include<stddef.h>

#include"lock.h"
#include"list.h"
#include"bool.h"

#ifndef NULL
#define NULL ((void *)0)
#endif

/* Default mutex queue length */
#define PTHREAD_MUTEX_QUEUE_LEN (PTHREADS_MAX / 4)

/* This pointer is relative to the user data space */
#ifndef PTHREAD_MUTEX_T
#define PTHREAD_MUTEX_T
typedef struct mutex {
	priority_t ceiling;
	bool_t dead;
	lock_t lock;
	list_t queue;
} pthread_mutex_t;
#endif

#ifndef PTHREAD_MUTEXATTR_T
#define PTHREAD_MUTEXATTR_T
typedef int pthread_mutexattr_t;
#endif

#define PTHREAD_MUTEX_INITIALIZER { FALSE, { 1, 0, NULL, { { NULL, NULL }, { NULL, NULL } }, NULL }
#define PTHREAD_MUTEXATTR_INITIALIZER PTHREAD_MUTEX_QUEUE_LEN

int pthread_mutexattr_getqueuelen(pthread_mutexattr_t *attr, int len);
int pthread_mutexattr_setqueuelen(pthread_mutexattr_t *attr, int len);

int pthread_mutex_init(pthread_mutex_t *mutex, pthread_mutexattr_t *attr);
int pthread_mutex_destroy(pthread_mutex_t *mutex);

int pthread_mutex_trylock(pthread_mutex_t *mutex);
int pthread_mutex_lock(pthread_mutex_t *mutex);
int pthread_mutex_unlock(pthread_mutex_t *mutex);

#endif
