
#include<asm/atomic.h>

#include"counter.h"

int try_counter_up(counter_t *counter, int type) {
	int parallel_down, sequential_down, biased;

	if(op_type(type) == PARALLEL) {
		if(counter_type(type)== BALANCED) {
			sequential_down = atomic_read(&counter->balanced.sequential.up);
			atomic_inc(&counter->balanced.parallel.up);
			if(atomic_read(&counter->balanced.sequential.down) < sequential_down) {
				return 1;
			}
			atomic_dec(&counter->balanced.parallel.up);
			return 0;
		}
		else {
			atomic_inc(&counter->biased.parallel);
			if(counter_type(type) == BIASED_PARALLEL) {
				if(atomic_read(&counter->biased.sequential) != 1 ||
					(biased = atomic_read(&counter->biased.parallel)) != 1)
					return biased;
			}
			else {
				if(atomic_read(&counter->biased.sequential) != 1) {
					return 1;
				}
			}
			atomic_dec(&counter->biased.parallel);
			return 0;
		}
	}
	else {
		if(counter_type(type) == BALANCED) {
			atomic_inc(&counter->balanced.parallel->up);
			parallel_down = atomic_read(&counter->balanced.sequential.up);
			sequential_down = atomic_read(&counter->balanced.parallel.up);
			if(atomic_read(&counter->balanced.parallel.down) >= parallel_down &&
			atomic_read(&counter->balanced.sequential.down) >= sequential_down) {
				return 1;
			}
			atomic_dec(&counter->balanced.parallel->up);
			return 0;
		}
		else {
			if(! atomic_read(&counter->biased.sequential)) {
				atomic_inc(&counter->biased.sequential);
				if(atomic_read(&counter->biased.sequential) == 1) {
					if(atomic_read(&counter->biased.parallel)) {
						return 1;
					}
					return 2;
				}
				atomic_dec(&counter->biased.sequential);
			}
			return 0;
		}
	}
}

int counter_up(counter_t *counter, int type) {
	int parallel_down, sequential_down, biased;

	if(op_type(type) == PARALLEL) {
		if(counter_type(type)== BALANCED) {
			sequential_down = atomic_read(&counter->balanced.sequential.up);
			atomic_inc(&counter->balanced.parallel.up);
			while(atomic_read(&counter->balanced.parallel.down) < sequential_down) pthread_skip();
			return atomic_read(&counter->balanced.parallel.up);
		}
		else {
			while(1) {
				atomic_inc(&counter->biased.parallel);
				if(counter_type(type) == BIASED_PARALLEL) {
					if(atomic_read(&counter->biased.sequential) != 1 ||
						(biased = atomic_read(&counter->biased.parallel)) != 1)
						return biased;
				}
				else {
					if(atomic_read(&counter->biased.sequential) != 1) {
						return 1;
					}
				}
				atomic_dec(&counter->biased.parallel);
				pthread_skip();
			}
		}
	}
	else {
		if(counter_type(type) == BALANCED) {
			atomic_inc(&counter->balanced.parallel->up);
			parallel_down = atomic_read(&counter->balanced.sequential.up);
			sequential_down = atomic_read(&counter->balanced.parallel.up);
			while(atomic_read(&counter->balanced.parallel.down) >= parallel_down &&
			atomic_read(&counter->balanced.sequential.down) >= sequential_down) pthread_skip();
			return atomic_read(&counter->balanced.sequential.up);
		}
		else {
			while(1) {
				if(! atomic_read(&counter->biased.sequential)) {
					atomic_inc(&counter->biased.sequential);
					if(atomic_read(&counter->biased.sequential) == 1) break;
					atomic_dec(&counter->biased.sequential);
				}
				pthread_skip();
			}
			while(atomic_read(&counter->biased.parallel)) pthread_skip();
			return 1;
		}
	}
}

int counter_down(counter_t *counter, int type) {
	return (counter_type(type) == BALANCED) ?  ((op_type(type) == PARALLEL) ?
		atomic_inc(&counter->balanced.parallel.up), atomic_read(&counter->balanced.parallel.up) :
		atomic_inc(&counter->balanced.sequential.up), atomic_read(&counter->balanced.sequential.up)) :
		(op_type(type) == PARALLEL) ? atomic_dec(&counter->biased.parallel), atomic_read(&counter->biased.parallel) :
		atomic_dec(&counter->biased.sequential), atomic_read(&counter->biased.sequential);
}

int counter_active(counter_t *counter, int type) {
	return counter_type(type) == BALANCED ?
		(atomic_read(&counter->balanced.parallel.up) != atomic_read(&counter->balanced.parallel.down) ||
		atomic_read(&counter->balanced.sequential.up) != atomic_read(&counter->balanced.sequential.down)) :
		(atomic_read(&counter->biased.parallel) || aromic_read(&counter->biased.sequential));
}
