#ifndef PTHREAD_H
#define PTHREAD_H

/*
    Copyright (C) 2006 Sundaresh Venugopal

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

    sundaresh@mail.com
*/

/* Author : sundaresh venugopal */

/* Maximum number of threads per process */
#define PTHREAD_MAX (16)

struct pthread;

#ifndef PTHREAD_T
#define PTHREAD_T
/* This pointer is relative to the kernel's data space */
typedef const struct pthread * const pthread_t;
#endif

#ifndef PTHREAD_ATOMIC_T
#define PTHREAD_ATOMIC_T
typedef enum { PTHREAD_NON_ATOMIC, PTHREAD_ATOMIC } pthread_atomic_t;
#endif

#ifndef PTHREAD_CANCEL_T
#define PTHREAD_CANCEL_T
typedef enum { PTHREAD_CANCEL_ENABLE, PTHREAD_CANCEL_DISABLE } pthread_cancel_t;
#endif

#include"mutex.h"
#include"cond.h"
#include"rwlock.h"

#endif
