#ifndef RWLOCK_H
#define RWLOCK_H
/*
    <one line to give the program's name and a brief idea of what it does.>
    Copyright (C) <year>  <name of author>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

    sundaresh@mail.com

*/

/* Author : sundaresh venugopal */

#include<time.h>

#include"bool.h"
#include"lock.h"
#include"counter.h"

#ifndef EBUSY
#define EBUSY
#endif

#ifndef PTHREAD_RWLOCKATTR_T
#define PTHREAD_RWLOCKATTR_T
typedef enum rwlock_attribute { RWLOCK_BALANCED, RWLOCK_STRONG_READER = 1, RWLOCK_STRONG_WRITER = 3 } pthread_rwlockattr_t;
#endif

#ifndef PTHREAD_RWLOCK_T
#define PTHREAD_RWLOCK_T
typedef struct rwlock {
	short once;
	bool_t dead;
	pthread_rwlockattr_t type;
	counter_t counter;
} pthread_rwlock_t;
#endif

/* These defenitions, structures are part of the user process, and not the kernel process */

/* Maximum number of rwlock's per process */
#define RWLOCK_MAX (PTHREAD_MAX * 4)

void rwlock_pool_init();

int pthread_rwlock_init(pthread_rwlock_t *rwlock, pthread_rwlockattr_t *attr);
int pthread_rwlock_destroy(pthread_rwlock_t *rwlock);

/* This function is non-standard , use macros instead */
int pthread_rwlock_trylock(pthread_rwlock_t *rwlock, bool_t write);
#define pthread_rwlock_tryrdlock(rwlock) (pthread_rwlock_trylock(rwlock, FALSE) <= 0)
#define pthread_rwlock_trywrlock(rwlock) (pthread_rwlock_trylock(rwlock, TRUE) <= 0)

/* This function is non-standard , use macros instead */
int pthread_rwlock_timedlock(pthread_rwlock_t *rwlock, bool_t write, struct timespec *abstime);
#define pthread_rwlock_timedrdlock(rwlock, abstime)
	(pthread_rwlock_timedlock(rwlock, FALSE, abstime) <= 0)
#define pthread_rwlock_rdlock(rwlock) (pthread_rwlock_timedlock(rwlock, FALSE, NULL) <= 0)
#define pthread_rwlock_timedwrlock(rwlock, abstime)
	(pthread_rwlock_timedlock(rwlock, TRUE, abstime) <= 0)
#define pthread_rwlock_wrlock(rwlock) (pthread_rwlock_timedlock(rwlock, TRUE, NULL) <= 0)

int pthread_rwlock_unlock(pthread_rwlock_t *rwlock);

#endif
